SymmetricCipherFinal< BASE, INFO > Class Template Reference

SymmetricCipher implementation. More...

`#include <strciphr.h>`

Inheritance diagram for SymmetricCipherFinal< BASE, INFO >:

## Public Member Functions

| SymmetricCipherFinal ()
| Construct a stream cipher.
| SymmetricCipherFinal (const byte *key)
| Construct a stream cipher.
| SymmetricCipherFinal (const byte *key, size_t length)
| Construct a stream cipher.
| SymmetricCipherFinal (const byte *key, size_t length, const byte *iv)
| Construct a stream cipher.
Clonable * | Clone () const
| Clone a SymmetricCipher.
Public Member Functions inherited from AlgorithmImpl< BASE, ALGORITHM_INFO >
std::string | AlgorithmName () const
| The algorithm name.

## Additional Inherited Members

Static Public Member Functions inherited from AlgorithmImpl< BASE, ALGORITHM_INFO >
static std::string | StaticAlgorithmName ()
| The algorithm name.

## Detailed Description

template<class BASE, class INFO = BASE>
class SymmetricCipherFinal< BASE, INFO >

SymmetricCipher implementation.

Template Parameters

  BASE | AbstractPolicyHolder derived base class
  INFO | AbstractPolicyHolder derived information class

See also
  Weak::ARC4, ChaCha8, ChaCha12, ChaCha20, Salsa20, SEAL, Sosemanuk, WAKE

Definition at line 683 of file strciphr.h.

## Constructor & Destructor Documentation

## ~SymmetricCipherFinal()

template<class BASE , class INFO = BASE>

virtual SymmetricCipherFinal< BASE, INFO >::~SymmetricCipherFinal | ( |  | ) |

inline virtual

Definition at line 686 of file strciphr.h.

## SymmetricCipherFinal() [1/4]

template<class BASE , class INFO = BASE>

SymmetricCipherFinal< BASE, INFO >::SymmetricCipherFinal | ( |  | ) |

inline

Construct a stream cipher.

Definition at line 689 of file strciphr.h.

## SymmetricCipherFinal() [2/4]

template<class BASE , class INFO = BASE>

SymmetricCipherFinal< BASE, INFO >::SymmetricCipherFinal | ( | const byte * | key | ) |

inline

Construct a stream cipher.

Parameters

  key | a byte array used to key the cipher

This overload uses DEFAULT_KEYLENGTH

Definition at line 694 of file strciphr.h.

## SymmetricCipherFinal() [3/4]

template<class BASE , class INFO = BASE>

SymmetricCipherFinal< BASE, INFO >::SymmetricCipherFinal | ( | const byte * | key,
|  | size_t | length
| ) |  |

inline

Construct a stream cipher.

Parameters

  key | a byte array used to key the cipher
  length | the size of the key array

Definition at line 700 of file strciphr.h.

## SymmetricCipherFinal() [4/4]

template<class BASE , class INFO = BASE>

SymmetricCipherFinal< BASE, INFO >::SymmetricCipherFinal | ( | const byte * | key,
|  | size_t | length,
|  | const byte * | iv
| ) |  |

inline

Construct a stream cipher.

Parameters

  key | a byte array used to key the cipher
  length | the size of the key array
  iv | a byte array used as an initialization vector

Definition at line 707 of file strciphr.h.

## Member Function Documentation

## Clone()

template<class BASE , class INFO = BASE>

Clonable * SymmetricCipherFinal< BASE, INFO >::Clone | ( |  | ) | const

inline

Clone a SymmetricCipher.

Returns
  a new SymmetricCipher based on this object

Definition at line 712 of file strciphr.h.

The documentation for this class was generated from the following file:

- strciphr.h